module Refactor where

import Data.Char (toLower, isSpace)


-- blatt 1

-- Vordefiniert. Solltet ihr verstehen.
isVowel :: Char -> Bool
isVowel = (`elem` "aeiou") . toLower

stripVowels :: String -> String
stripVowels "" = ""
stripVowels (c:cs) | isVowel c = toLower c : stripVowels cs
                   | otherwise = stripVowels cs

stripVowels' :: String -> String
stripVowels' _ = undefined

encrypt :: String -> String
encrypt "" = ""
encrypt (c:cs) | isVowel c = c : 'p' : toLower c : encrypt cs
               | otherwise = c :                   encrypt cs

encrypt' :: String -> String
encrypt' _ = undefined


-- blatt 2

type Line = [String]

numWords :: Line -> Int
numWords []     = 0
numWords (_:ls) = 1 + numWords ls

numWords' :: Line -> Int
numWords' _ = undefined

len :: Line -> Int
len []     = 0
len (s:ls) = length s + len ls

len' :: Line -> Int
len' _ = undefined

app :: Line -> String -> Line
app []      s = [s]
app (s':ls) s = s' : app ls s

app' :: Line -> String -> Line
app' _ _ = undefined

lineToString :: Line -> String
lineToString []     = ""
lineToString [s]    = s
lineToString (s:ls) = s ++ " " ++ lineToString ls

lineToString' :: Line -> String
lineToString' _ = undefined

